/**

Copyright (c) Scott Gasch

Module Name:

    system.h

Abstract:

Author:

    Scott Gasch (scott@wannabe.guru.org) 8 Apr 2004

Revision History:

    $Id: compiler.h 349 2008-06-28 02:48:59Z scott $

**/

#ifndef COMPILER_H_
#define COMPILER_H_


#include <inttypes.h>

#if defined(_WIN32) || defined(_WIN64)
#include <windows.h>
#include <io.h>
#include <errno.h>

static inline int32_t fchmod(int32_t fildes, uint32_t mode)
{ errno = ENOSYS; return -1; }

#define COMPILER_LONGLONG_HEX_FORMAT "I64x"
#define COMPILER_LONGLONG_UNSIGNED_FORMAT "I64u"
#else
#include <unistd.h>
extern int32_t errno;
#define CDECL     __attribute__((cdecl))
#define FASTCALL  __attribute__((regparm__(3)))
#define COMPILER_LONGLONG_HEX_FORMAT "llx"
#define COMPILER_LONGLONG_UNSIGNED_FORMAT "llu"
#define O_BINARY                   (0)
#define O_RANDOM                   (0)
#define _S_IREAD                   (0)
#define _S_IWRITE                  (0)
#endif

#define COMPILER_STRING            "GCC "__VERSION__"\n"
#define BUILD_STRING               __OPTIMIZE__


#define ALIGN64 // __attribute__ (aligned(64)) does not work
#define COMPILER_LONGLONG          int64_t
#define COMPILER_VSNPRINTF         vsnprintf
#define INLINE                     __inline__

#define NORETURN                   __attribute__((noreturn))
#define CONSTFUNCT                 __attribute__((const))

#define STRNCMPI                   strncasecmp
#define STRCMPI                    strcasecmp
#define STRDUP                     SystemStrDup
#define TB_FASTCALL // __attribute__((__regparm__(3)))

#endif /* COMPILER_H_ */
